function C=bingenop(A,B,op)
  % binary generic operator
  % A could be an amat object, a m-by-n matrix, a N-by-1 array or a scalar
  % B could be an amat object, a m-by-n matrix, a N-by-1 array or a scalar
  % amat.isamat(a) || amat.isamat(b)
  %assert(sum(strcmp(func2str(op),{'times','power','rdivide','ldivide','plus','minus','eq','ge','gt','le','lt','ne','isequal','and','or'}))==1)
  isAamat=isamat(A);isBamat=isamat(B);
  assert( isAamat || isBamat , 'One of the two first parameters must be a <amat> object')
  if isAamat && isBamat
    assert( all(size(A)==size(B)) , 'not the same size')
    C=amat(op(A.values,B.values));
    return
  end
  if isscalar(A) || isscalar(B) % One is a scalar
    C=amat(op(get_values(A),get_values(B)));
    return
  end
  %if isAamat && size(A,0)~=size(B,1), B=reshape(B,[1 size(B)]);end % B is a m-by-n matrix
  %if isBamat && size(A,1)~=size(B,0), A=reshape(A,[1 size(A)]);end % A is a m-by-n matrix
  if isAamat, B=fc_amat.to3Darray(B,[A.N,A.nr,A.nc]);end % B is a m-by-n matrix
  if isBamat, A=fc_amat.to3Darray(A,[B.N,B.nr,B.nc]);end % A is a m-by-n matrix
  C=amat(op(get_values(A),get_values(B)));
end

function vals=get_values(A)
  if isamat(A) 
    vals=A.values;
  else
    vals=A;
  end
end

function X=Conv(X,N)
  if  ~fc_tools.comp.isOctave() && verLessThan('matlab','9.1.0') % Matlab < 2016b
    X=permute(repmat(X,[1,1,N]),[3,1,2]);
  else
    X=reshape(X,[1 size(X)])
  end
end
